DAT programName         byte "PingUnitsDemo141206a", 0
CON
{{
  By Duane Degn
  December 6, 2014

  Demo program to illustrate the some of the
  methods in the "EddiePing" object.
  
}}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  PING_PIN = 1 
  DEBUG_BAUD = 115_200                               
                                        
  DEFAULT_INTER_PING_DELAY = 50 ' in milliseconds
'' The minimum delay should probably be about
'' 20ms in order for the previous echos to die
'' down. The delay should be long enough to allow
'' for any delays caused by serial output. If the
'' delay is too short a waitcnt statement may
'' cause the program to freeze.
'' In this demo program, the delay could probably
'' be removed without causing a problem since the
'' calls to the serial object will likely produce
'' delays long enough to allow any echos to die
'' down.
'' Using a delay between Ping reading is likely
'' most important when using multiple Ping
'' sensors at the same time. 
  
VAR

  long range
  long pingTimer, pingInterval
    
OBJ

  Ping : "EddiePing141206a"
  Pst  : "Parallax Serial Terminal"
         
PUB Start

  Pst.Start(DEBUG_BAUD)
  
  'waitcnt(clkfreq * 2 + cnt) ' uncomment this line to add delay to start of program
  Pst.Clear
  Pst.Home
  Pst.Str(String(11, 13, "This program ", 34))
  Pst.Str(@programName)
  Pst.Str(String(34, " demonstates the various units available"))
  Pst.Str(String(11, 13, "when readings distances with the object ", 34))
  Pst.Str(Ping.GetObjectName)
  Pst.Str(String(34, ".", 11, 13))
  Ping.Init
  pingInterval := DEFAULT_INTER_PING_DELAY * (clkfreq / 1000)
  pingTimer := cnt
  
  repeat                                 
    ' Comment out the 8 lines below to scroll data.
    Pst.ClearBelow
    Pst.Home
    Pst.Str(String(11, 13, "This program ", 34))
    Pst.Str(@programName)
    Pst.Str(String(34, " demonstates the various units available"))
    Pst.Str(String(11, 13, "when readings distances with the object ", 34))
    Pst.Str(Ping.GetObjectName)
    Pst.Str(String(34, ".", 11, 13))
     ' Comment out the 8 lines above to scroll data.
    
    range := Ping.Inches(PING_PIN)                      
    Pst.Str(string(13, "Inches = "))
    Pst.Dec(range)                                    
    waitcnt(pingTimer += pingInterval)
    range := Ping.TenthsOfInch(PING_PIN)                 
    Pst.Str(string(" in, inches = "))
    Pst.Dec(range / 10)                           
    Pst.Char(".")                                  
    Pst.Dec(range // 10)                            
    waitcnt(pingTimer += pingInterval)
    range := Ping.Centimeters(PING_PIN)                
    Pst.Str(string(" in, centimeters = "))
    Pst.Dec(range)
    waitcnt(pingTimer += pingInterval)
    range := Ping.Millimeters(PING_PIN)                 
    Pst.Str(string(" cm, centimeters = "))
    Pst.Dec(range / 10)                           
    Pst.Char(".")                                      
    Pst.Dec(range // 10)                            
    waitcnt(pingTimer += pingInterval)
    range := Ping.Microseconds(PING_PIN)               
    Pst.Str(string(" cm, microseconds = "))
    Pst.Dec(range)
    waitcnt(pingTimer += pingInterval)
    range := Ping.EddieUnits(PING_PIN)               
    Pst.Str(string(" us, Eddie Units = "))
    Pst.Dec(range)
    Pst.ClearEnd
    Pst.NewLine
    waitcnt(pingTimer += pingInterval)
    
{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

}}       